#include <QTRSensors.h>

QTRSensors qtr;

const uint8_t SensorCount = 6;
uint16_t sensorValues[SensorCount];


//2 = dopredu, 1 = dozadu
#define right1 10
#define right2 11
#define left1 5
#define left2 6

#define TRIG 8
#define ECHO 9

#define defaultRight 46
#define defaultLeft 50
#define upperBound 800
#define lowerBound 300

void setup() {
  pinMode(TRIG, OUTPUT);
  pinMode(ECHO, INPUT);
  pinMode(right1, OUTPUT);
  pinMode(right2, OUTPUT);
  pinMode(left1, OUTPUT);
  pinMode(right2, OUTPUT);

  qtr.setTypeRC();
  qtr.setSensorPins((const uint8_t[]){A0, A1, A2, A3, A4, A5}, SensorCount);
  qtr.setEmitterPin(2);

  delay(500);
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH);
  for (uint16_t i = 0; i < 400; i++)
  {
    qtr.calibrate();
  }
  digitalWrite(LED_BUILTIN, LOW);
  delay(1000);
}

int meraj() {
  digitalWrite(TRIG, HIGH);
  delayMicroseconds(10);
  digitalWrite(TRIG, LOW);
  while (digitalRead(ECHO) == 0) { }
  long cas1 = micros();
  while (digitalRead(ECHO) == 1) { }
  long cas2 = micros();
  return (cas2 - cas1) / 58;
}


void loop() {
  int d = meraj();
  uint16_t position = qtr.readLineBlack(sensorValues);
  //rovno
  if (sensorValues[2] >= upperBound && sensorValues[3] >= upperBound){
    digitalWrite(right1, 0);
    analogWrite(right2, defaultRight);
    digitalWrite(left1, 0);
    analogWrite(left2, defaultLeft);
  }
  //mierne vpravo
  else if (sensorValues[1] >= upperBound && sensorValues[2] >= upperBound) {
    digitalWrite(right1, 0);
    analogWrite(right2, defaultRight);
    digitalWrite(left1, 0);
    analogWrite(left2, defaultLeft + 15);
  }
  //mierne vlavo
  else if (sensorValues[3] >= upperBound && sensorValues[4] >= upperBound) {
    digitalWrite(right1, 0);
    analogWrite(right2, defaultRight + 15);
    digitalWrite(left1, 0);
    analogWrite(left2, defaultLeft);
  }
  //vlavo
  else if (sensorValues[5] >= upperBound) {
    digitalWrite(right1, 0);
    analogWrite(right2, defaultRight);
    digitalWrite(left1, 0);
    digitalWrite(left2, 0);
  }
  //vpravo
  else if (sensorValues[0] >= upperBound){
    digitalWrite(right1, 0);
    digitalWrite(right2, 0);
    digitalWrite(left1, 0);
    analogWrite(left2, defaultLeft);
  }
  //follower mode
  else {
    int d = meraj();
    if (d >= 15 && d <= 50) {
      analogWrite(right2,80);
      analogWrite(left2, 70);
      digitalWrite(right1, 0);
      digitalWrite(left1, 0);
    }
    else if (d < 7) {
      analogWrite(right1, 85);
      analogWrite(left1, 70);
      digitalWrite(right2, 0);
      digitalWrite(left2, 0);
    }
    else if (d > 50) {
      analogWrite(right1, 40);
      digitalWrite(right2, 0);
      digitalWrite(left1, 0);
      analogWrite(left2, 40);
    }
    else {
      digitalWrite(right1, 0);
      digitalWrite(right2, 0);
      digitalWrite(left1, 0);
      digitalWrite(left2, 0);
    }
    delay(300);
  }
}
